#!/bin/sh

reset() {
    iptables -D INPUT -j fieryfilter_in
    iptables -D OUTPUT -j fieryfilter_out
    iptables -D FORWARD -j fieryfilter_for 

    iptables -F fieryfilter_in
    iptables -X fieryfilter_in
    iptables -F fieryfilter_out
    iptables -X fieryfilter_out
    iptables -F fieryfilter_for
    iptables -X fieryfilter_for
    iptables -F fieryfilter
    iptables -X fieryfilter
}

create() {
    iptables -N fieryfilter
    iptables -A fieryfilter -s 127.0.0.0/8 -d 127.0.0.0/8 -j ACCEPT
    iptables -A fieryfilter -m state --state ESTABLISHED -j ACCEPT
    iptables -A fieryfilter -m state --state RELATED -j ACCEPT
    iptables -A fieryfilter -m state --state NEW -j RETURN
    iptables -A fieryfilter -j DROP

    iptables -N fieryfilter_in
    iptables -A fieryfilter_in -j fieryfilter

    iptables -N fieryfilter_out
    iptables -A fieryfilter_out -j fieryfilter
    iptables -A fieryfilter_out -p icmp --icmp-type destination-unreachable -j ACCEPT

    grep nameserver /etc/resolv.conf | sed s/nameserver// | {
        while read ip ; do
            iptables -A fieryfilter_out -p udp --dport 53 -d $ip -j ACCEPT
        done
    }

    iptables -N fieryfilter_for
    iptables -A fieryfilter_for -j fieryfilter
}

activate() {
    iptables -A INPUT -j fieryfilter_in
    iptables -A OUTPUT -j fieryfilter_out
    iptables -A FORWARD -j fieryfilter_for
}

modprobe iptable_filter
modprobe ip_queue
rm -f /tmp/fieryfilter

reset 2> /dev/null
create
activate
./daemon/fieryfilterd

reset 2> /dev/null
